unit Elements;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Grids;

type
  TElementForm = class(TForm)
    ElementGrid: TStringGrid;
    procedure GoCreateElementForm(Sender: TObject);
  private
    { Private declarations }
    NewElement: Boolean;
    IncRows: Boolean;
  public
    { Public declarations }
    Procedure ClearElements;
    Procedure AddElement(Nm: String; ArrivalTime: Double; Status: String;
     EventTime: Double);
    Procedure AddQueue(Nm: String; QueueTime: Double);
  end;

var
  ElementForm: TElementForm;

implementation

{$R *.DFM}

Const
  NEVER: Double = 1.7E+307;

procedure TElementForm.GoCreateElementForm(Sender: TObject);
Var
  I: Integer;
begin
With ElementGrid Do
  Begin
  I:=Font.Size;
  RowCount:=2;
  IncRows:=FALSE;
  FixedRows:=1;
  ColWidths[0]:= I * 20;
  ColWidths[1]:= I * 10;
  ColWidths[2]:= I * 20;
  ColWidths[3]:= I * 10;
  ColWidths[4]:= I * 20;
  ColWidths[5]:= I * 10;
  Cells[0,0]:='Name';
  Cells[1,0]:='ArrivalTime';
  Cells[2,0]:='Status';
  Cells[3,0]:='Eventtime';
  Cells[4,0]:='Queue';
  Cells[5,0]:='QueueTime';
  End;
end;

Procedure TElementForm.ClearElements;
  Begin
  With ElementGrid Do
    Begin
    RowCount:=2;
    IncRows:=FALSE;
    FixedRows:=1;
    Cells[0,0]:='Name';
    Cells[1,0]:='ArrivalTime';
    Cells[2,0]:='Status';
    Cells[3,0]:='Eventtime';
    Cells[4,0]:='Queue';
    Cells[5,0]:='QueueTime';
    End;
  End;

Procedure TElementForm.AddElement(Nm: String; ArrivalTime: Double; Status: String;
 EventTime: Double);
  Var
    Ix: Integer;
  Begin
  If IncRows Then
    Begin
    ElementGrid.RowCount:=ElementGrid.RowCount + 1;
    End
  Else
    Begin
    IncRows:=TRUE;
    End;
  Ix:=ElementGrid.RowCount - 1;
  ElementGrid.Cells[0,Ix]:=Nm;
  ElementGrid.Cells[1,Ix]:=FormatFloat('0.00',ArrivalTime);
  ElementGrid.Cells[2,Ix]:=Status;
  If EventTime = Never Then
    Begin
    ElementGrid.Cells[3,Ix]:='Never';
    End
  Else
    Begin
    ElementGrid.Cells[3,Ix]:=FormatFloat('0.00',EventTime);
    End;
  NewElement:=TRUE;
  End;

Procedure TElementForm.AddQueue(Nm: String; QueueTime: Double);
  Var
   Ix: Integer;
  Begin
  If NewElement Then
    Begin
    Ix:=ElementGrid.RowCount -1;
    ElementGrid.Cells[4,Ix]:=Nm;
    ElementGrid.Cells[5,Ix]:=FormatFloat('0.00',QueueTime);
    NewElement:=FALSE;
    End
  Else
    Begin
    ElementGrid.RowCount:=ElementGrid.RowCount + 1;
    Ix:=ElementGrid.RowCount - 1;
    ElementGrid.Cells[0,Ix]:='';
    ElementGrid.Cells[1,Ix]:='';
    ElementGrid.Cells[2,Ix]:='';
    ElementGrid.Cells[3,Ix]:='';
    ElementGrid.Cells[4,Ix]:=Nm;
    ElementGrid.Cells[5,Ix]:=FormatFloat('0.00',QueueTime);
    End;
  End;

end.
